(function($) {
    $.fn.jquizzy = function(settings) {
        // 倒计时
        var intDiff = parseInt(2700), //倒计时总秒数量
            timers = null,
            userAnswers = [];
        var day = 0,
            hour = 0,
            minute = 0,
            second = 0; //时间默认值       

        var defaults = {
            questions: null,
            startImg: 'images/start.gif',
            endText: '已结束!',
            shortURL: null,
            // sendResultsURL: "http://192.168.0./webapi/llks",
            resultComments: {
                perfect: '',
                excellent: '',
                good: '',
                average: '',
                bad: '',
                poor: '',
                worst: ''
            }
        };
        var config = $.extend(defaults, settings);
        if (config.questions === null) {
            $(this).html('<div class="intro-container slide-container"><h2 class="qTitle">Failed to parse questions.</h2></div>');
            return;
        }
        var superContainer = $(this),
            id,
            answers = [],
            introFob = '<div class="intro-container slide-container"><a href=\"#\"><section class=\"content bgcolor-8\"><span class=\"input input--isao\"></span><div class=\"start-answer nav-start\" style=display:none></div></section></a></div>',
            exitFob = '<div class="results-container slide-container"><div class="question-number">' + config.endText + '</div><div class="result-keeper"></div></div><div class="notice">请选择一个选项！</div><div class="showQuestion"></div><div class="progress-keeper" ><div class="progress"></div></div>',
            contentFob = '',
            questionsIteratorIndex,
            answersIteratorIndex;
        superContainer.addClass('main-quiz-holder');
        for (questionsIteratorIndex = 0; questionsIteratorIndex < config.questions.length; questionsIteratorIndex++) {
            contentFob += '<div class="slide-container"><div class="question-number">' + (questionsIteratorIndex + 1) + '/' + config.questions.length + '</div><div class="question">' + (questionsIteratorIndex + 1) + "." + config.questions[questionsIteratorIndex].question + '</div><ul class="answers">';
            for (answersIteratorIndex = 0; answersIteratorIndex < config.questions[questionsIteratorIndex].answers.length; answersIteratorIndex++) {
                contentFob += '<li>' + config.questions[questionsIteratorIndex].answers[answersIteratorIndex] + '</li>';
            }
            contentFob += '</ul><div class="nav-container">';
            if (questionsIteratorIndex !== 0) {
                // contentFob += '<div class="prev"><a class="nav-previous" href="#">&lt; 上一题</a></div>';
            }
            if (questionsIteratorIndex < config.questions.length - 1) {
                contentFob += '<div class="next"><a class="nav-next" href="#">下一题 &gt;</a></div>';
            } else {
                contentFob += '<div class="next final"><a class="nav-show-result" href="#">完成</a></div>';
            }
            contentFob += '</div></div>';
            answers.push(config.questions[questionsIteratorIndex].correctAnswer);
        }

        superContainer.html(introFob + contentFob + exitFob);
        var progress = superContainer.find('.progress'),
            progressKeeper = superContainer.find('.progress-keeper'),
            notice = superContainer.find('.notice'),
            showQuestion = superContainer.find('.showQuestion'),
            progressWidth = progressKeeper.width(),
            questionLength = config.questions.length,
            slidesList = superContainer.find('.slide-container'),
            questionNumber,
            userQuestionAnswers,
            computerQuestionAnswers,
            computer_Answers,
            Chooseflag = true;


        function timer(intDiff) {
            timers = window.setInterval(function() {

                if (intDiff > 0) {
                    day = Math.floor(intDiff / (60 * 60 * 24));
                    hour = Math.floor(intDiff / (60 * 60)) - (day * 24);
                    minute = Math.floor(intDiff / 60) - (day * 24 * 60) - (hour * 60);
                    second = Math.floor(intDiff) - (day * 24 * 60 * 60) - (hour * 60 * 60) - (minute * 60);
                }
                if (minute <= 9) minute = '0' + minute;
                if (second <= 9) second = '0' + second;
                $('#minute_show').html('<s></s>' + minute + '分');
                $('#second_show').html('<s></s>' + second + '秒');
                intDiff--;

                if (intDiff < 0) {
                    window.clearInterval(timers);
                    $('.slide-container').hide();
                    $('.progress-keeper').hide();
                    $('.results-container').show(500);
                    $('.result-keeper').html("时间到考试结束").show(500);
                    $('.resultsview-qhover').hide();
                    var results = checkAnswers(),
                        score_timeout,
                        trueCount = 0;
                    $('li.selected').each(function(index) {
                        userAnswers.push($(this).parents('.answers').children('li').index($(this).parents('.answers').find('li.selected')) + 1);
                    });
                    for (var i = 0; i < userAnswers.length; i++) {
                        if (userAnswers[i] == answers[i]) {
                            trueCount++;
                        }
                    }
                    // score_timeout 分数 id 时间
                    score_timeout = roundReloaded(trueCount / questionLength * 100, 2);

                    $.ajax({
                        url: config.sendResultsURL,
                        type: "get",
                        dataType: "jsonp",
                        data: "cardId=" + id + "&score=" + score_timeout.toString() + "&time=0000",
                        jsonp: 'callback',
                        jsonpCallback: "callback",
                        success: function(data) {
                            test_result = data[0].res;
                            if (test_result == 1) {
                                console.log("提交成绩成功");
                            }
                        },
                        error: function() {
                            alert("error")
                        },
                        async: false
                    });


                }
            }, 1000);
        }


        function checkAnswers() {

            var resultArr = [],
                flag = false;
            for (i = 0; i < answers.length; i++) {
                if (answers[i] == userAnswers[i]) {
                    flag = true;
                } else {
                    flag = false;
                }
                resultArr.push(flag);
            }
            return resultArr;
        }

        function roundReloaded(num, dec) {
            var result = Math.round(num * Math.pow(10, dec)) / Math.pow(10, dec);
            return result;
        }

        function judgeSkills(score) {
            var returnString;
            if (score === 100) return config.resultComments.perfect;
            else if (score > 90) return config.resultComments.excellent;
            else if (score > 70) return config.resultComments.good;
            else if (score > 50) return config.resultComments.average;
            else if (score > 35) return config.resultComments.bad;
            else if (score > 20) return config.resultComments.poor;
            else return config.resultComments.worst;
        }
        progressKeeper.hide();
        notice.hide();
        showQuestion.hide();
        slidesList.hide().first().fadeIn(500);
        var clickAnswers = true;
        superContainer.find('li').click(function() {
            var thisLi = $(this);
            if (clickAnswers) {
                clickAnswers = true;
                if (thisLi.hasClass('selected')) {
                    thisLi.removeClass('selected');
                } else {
                    thisLi.parents('.answers').children('li').removeClass('selected');
                    thisLi.addClass('selected');
                    questionNumber = $(this).parent().parent().index(); //题目
                    userQuestionAnswers = $(this).index() + 1; //答题者答案
                    computerQuestionAnswers = answers[$(this).parent().parent().index() - 1] //正确答案
                    computer_Answers = config.questions[questionNumber - 1].answers[computerQuestionAnswers - 1]
                        // if (userQuestionAnswers == computerQuestionAnswers) {
                        //     showQuestion.html("恭喜您答对了").show();
                        // } else {
                        //     showQuestion.html("这道题答错咯!!! 正确答案是:" + computer_Answers).show();
                        // }
                    Chooseflag = false;
                }
            }
        });

        // 判断身份证
        function getUrl(name) {
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
            var r = window.location.search.substr(1).match(reg);
            if (r != null) return unescape(r[2]);
            return "";
        }
        var urlId = getUrl('idcard');
        // $(".ID").html(urlId);
        //判断身份证
        /*  if (urlId != "") {
              $(".ID").html(urlId);
              var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
              if (reg.test(urlId) === false) {
                  alert("身份证输入不合法");
              } else {
                  superContainer.find('.nav-start').parents('.slide-container').fadeOut(500,
                      function() {
                          $(this).next().fadeIn(500);
                          $(".Answer-time-score").fadeIn(500);
                          timer(intDiff);
                          progressKeeper.fadeIn(500);
                      });
              }

          } */
        superContainer.find('.nav-start').click(function() {
            $(this).parents('.slide-container').fadeOut(500,
                function() {
                    $(this).next().fadeIn(500);
                    $(".Answer-time-score").fadeIn(500);
                    timer(intDiff);
                    progressKeeper.fadeIn(500);
                });
            return false;
        });
        superContainer.find('.nav-start').parents('.slide-container').hide(0,
            function() {
                superContainer.find('.nav-start').parents('.slide-container').next().fadeIn(500);
                $(".Answer-time-score").fadeIn(500);
                timer(intDiff);
                progressKeeper.fadeIn(500);
            });
        superContainer.find('.next').click(function() {
            if (Chooseflag) {
                notice.fadeIn(100);
                return false;
            }
            Chooseflag = true;
            var that = $(this);

            if (userQuestionAnswers == computerQuestionAnswers) {
                // showQuestion.html("恭喜您答对了").show();
                that.parents('.slide-container').fadeOut(100,
                    function() {
                        clickAnswers = true;
                        $(this).next().fadeIn(500);
                    });
                showQuestion.hide();
            } else {
                showQuestion.html("<img class='wran_img' src='images/warn.png'>正确答案是:" + computer_Answers).show();
            }
            clickAnswers = false;
            notice.hide();
            setTimeout(function() {
                that.parents('.slide-container').fadeOut(100,
                    function() {
                        clickAnswers = true;
                        $(this).next().fadeIn(500);
                    });
                showQuestion.hide();
            }, 3000)


            progress.animate({
                    width: progress.width() + Math.round(progressWidth / questionLength)
                },
                500);
            return false;
        });
        superContainer.find('.prev').click(function() {
            notice.hide();
            $(this).parents('.slide-container').fadeOut(500,
                function() {
                    $(this).prev().fadeIn(500);
                });
            progress.animate({
                    width: progress.width() - Math.round(progressWidth / questionLength)
                },
                500);
            return false;
        });
        superContainer.find('.final').click(function() {
            window.clearInterval(timers);
            var time = 2700 - (minute * 60 + second);
            if ($(this).parents('.slide-container').find('li.selected').length === 0) {
                notice.fadeIn(300);
                return false;
            }
            superContainer.find('li.selected').each(function(index) {
                userAnswers.push($(this).parents('.answers').children('li').index($(this).parents('.answers').find('li.selected')) + 1);
            });

            progressKeeper.hide();
            var results = checkAnswers(),
                score,
                resultSet = '',
                trueCount = 0,
                shareButton = '',
                url;
            if (config.shortURL === null) {
                config.shortURL = window.location
            };
            for (var i = 0,
                    toLoopTill = results.length; i < toLoopTill; i++) {
                if (results[i] === true) {
                    trueCount++;
                    isCorrect = true;
                }
                resultSet += '<div class="result-row">' + (results[i] === true ? "<div class='correct'>题" + (i + 1) + "<span></span></div>" : "<div class='wrong'>#" + (i + 1) + "<span></span></div>");
                resultSet += '<div class="resultsview-qhover">' + config.questions[i].question;
                resultSet += "<ul>";
                for (answersIteratorIndex = 0; answersIteratorIndex < config.questions[i].answers.length; answersIteratorIndex++) {
                    var classestoAdd = '';
                    if (config.questions[i].correctAnswer == answersIteratorIndex + 1) {
                        classestoAdd += 'right';
                    }
                    if (userAnswers[i] == answersIteratorIndex + 1) {
                        classestoAdd += ' selected';
                    }
                    resultSet += '<li class="' + classestoAdd + '">' + config.questions[i].answers[answersIteratorIndex] + '</li>';
                }
                resultSet += '</ul></div></div>';
            }
            score = roundReloaded(trueCount / questionLength * 100, 2);
            var score_string = score.toString();
            if (config.sendResultsURL !== null) {
                var collate = [];
                for (r = 0; r < userAnswers.length; r++) {
                    collate.push('{"questionNumber":"' + parseInt(r + 1, 10) + '", "userAnswer":"' + userAnswers[r] + '"}');
                }
                // var id = $('.ID').html();
                var year = $('input[name=year]').val().replace(/[^\d]/g, '');
                var babyNum = $('input[name=babyNum]').val().replace(/[^\d]/g, '');
                // todo
                $.ajax({
                    url: hostUrl + 'llks',
                    type: "get",
                    dataType: "jsonp",
                    data: {
                        eid: UserInfo.userId(),
                        score: score_string,
                        history_order: babyNum,
                        history_year: year
                    },
                    jsonp: 'callback',
                    jsonpCallback: "callback",
                    success: function(data) {
                        var ysMe = plus.webview.getWebviewById('pages/ys-me.html');
                        mui.fire(ysMe, 'perfectList');
                        setTimeout(function() {
                                mui.back();
                            }, 2000)
                            /* test_result = data[0].res;
                             if (test_result == 1) {
                                 alert("提交成绩成功");
                             }*/
                    },
                    error: function() {},
                    async: false
                });

            }

            mui('body').on('tap', '.results-btn', function() {
                    plus.webview.currentWebview().reload()
                })
                /* mui('body').on('tap', '.resultsview-qhover', function() {
                     $('.resultsview-qhover').hide();
                 })*/
            if (score < 60) {
                resultSet = '<h2 class="qTitle">' + judgeSkills(score) + '<br/> 理论知识考核分数 ' + score + '</h2>' + shareButton + '<div class="jquizzy-clear"></div>' + resultSet + '<div class=""><a class="results-btn" href=../exam/exam.html>考核不通过,点击重新开始考核</a></div>'; //

            } else {
                resultSet = '<h2 class="qTitle">' + judgeSkills(score) + '<br/> 理论知识考核分数 ' + score + '</h2>' + shareButton + '<div class="jquizzy-clear"></div>' + resultSet + '<div class=""></div>'; //<a class="results-btn" href=exam-color.html>恭喜通过笔试考核,立即前往性格测试</a>
            }
            superContainer.find('.result-keeper').html(resultSet).show(500);
            superContainer.find('.resultsview-qhover').hide();

            superContainer.find('.result-row').hover(function() {
                    $(this).find('.resultsview-qhover').show();
                },
                function() {
                    $(this).find('.resultsview-qhover').hide();
                });
            $(this).parents('.slide-container').fadeOut(500,
                function() {
                    $(this).next().fadeIn(500);
                });

            return false;
        });
    };
})(jQuery);
