﻿(function($) {
    $.fn.jquizzy = function(settings) {
        // 倒计时
        var intDiff = parseInt(2700), //倒计时总秒数量
            timers = null,
            userAnswers = [];
        var day = 0,
            hour = 0,
            minute = 0,
            second = 0; //时间默认值       

        var defaults = {
            questions: null,
            startImg: 'images/start.gif',
            endText: '已结束!',
            shortURL: null,
            sendResultsURL: "http://api.bama77.com/otherapi/scAssessment",
            resultComments: {
                perfect: '',
                excellent: '',
                good: '',
                average: '',
                bad: '',
                poor: '',
                worst: ''
            }
        };
        var config = $.extend(defaults, settings);
        if (config.questions === null) {
            $(this).html('<div class="intro-container slide-container"><h2 class="qTitle">Failed to parse questions.</h2></div>');
            return;
        }
        var superContainer = $(this),
            id,
            answers = [],
            // introFob = ' <div class="intro-container slide-container"><a href=\"#\"><section class=\"content bgcolor-8\"><h3>请输入身份证号,准备好点击开始答题!</h3><span class=\"input input--isao\"><input class=\"input__field input__field--isao\"type=\"text\"id=\"input-38\"/><label class=\"input__label input__label--isao\"for=\"input-38\"data-content=\"身份证号码\"><span class=\"input__label-content input__label-content--isao\">身份证号码</span></label></span><div class=\"start-answer nav-start\">开始答题</div></section></a></div>',
            exitFob = '<div class="results-container slide-container"><div class="question-number">' + config.endText + '</div><div class="result-keeper"></div></div><div class="notice">请选择一个选项！</div><div class="showQuestion"></div><div class="progress-keeper" ><div class="progress"></div></div>',
            contentFob = '',
            questionsIteratorIndex,
            answersIteratorIndex;
        superContainer.addClass('main-quiz-holder');
        for (questionsIteratorIndex = 0; questionsIteratorIndex < config.questions.length; questionsIteratorIndex++) {
            contentFob += '<div class="slide-container"><div class="question-number">' + (questionsIteratorIndex + 1) + '/' + config.questions.length + '</div><div class="question">' + config.questions[questionsIteratorIndex].question + '</div><ul class="answers">';
            for (answersIteratorIndex = 0; answersIteratorIndex < config.questions[questionsIteratorIndex].answers.length; answersIteratorIndex++) {
                contentFob += '<li>' + config.questions[questionsIteratorIndex].answers[answersIteratorIndex] + '</li>';
            }
            contentFob += '</ul><div class="nav-container">';
            if (questionsIteratorIndex !== 0) {
                contentFob += '<div class="prev"><a class="nav-previous" href="#">&lt; 上一题</a></div>';
            }
            if (questionsIteratorIndex < config.questions.length - 1) {
                contentFob += '<div class="next"><a class="nav-next" href="#">下一题 &gt;</a></div>';
            } else {
                contentFob += '<div class="next final"><a class="nav-show-result" href="#">完成</a></div>';
            }
            contentFob += '</div></div>';
            answers.push(config.questions[questionsIteratorIndex].correctAnswer);
        }

        superContainer.html(contentFob + exitFob);
        var progress = superContainer.find('.progress'),
            progressKeeper = superContainer.find('.progress-keeper'),
            notice = superContainer.find('.notice'),
            showQuestion = superContainer.find('.showQuestion'),
            progressWidth = progressKeeper.width(),
            questionLength = config.questions.length,
            slidesList = superContainer.find('.slide-container');



        function timer(intDiff) {
            timers = window.setInterval(function() {

                if (intDiff > 0) {
                    day = Math.floor(intDiff / (60 * 60 * 24));
                    hour = Math.floor(intDiff / (60 * 60)) - (day * 24);
                    minute = Math.floor(intDiff / 60) - (day * 24 * 60) - (hour * 60);
                    second = Math.floor(intDiff) - (day * 24 * 60 * 60) - (hour * 60 * 60) - (minute * 60);
                }
                if (minute <= 9) minute = '0' + minute;
                if (second <= 9) second = '0' + second;
                $('#minute_show').html('<s></s>' + minute + '分');
                $('#second_show').html('<s></s>' + second + '秒');
                intDiff--;

                if (intDiff < 0) {
                    window.clearInterval(timers);
                    $('.slide-container').hide();
                    $('.progress-keeper').hide();
                    $('.results-container').show(500);
                    $('.result-keeper').html("时间到考试结束").show(500);
                    $('.resultsview-qhover').hide();
                    var results = checkAnswers(),
                        score_timeout,
                        trueCount = 0;
                    $('li.selected').each(function(index) {
                        userAnswers.push($(this).parents('.answers').children('li').index($(this).parents('.answers').find('li.selected')) + 1);
                    });
                    for (var i = 0; i < userAnswers.length; i++) {
                        if (userAnswers[i] == answers[i]) {
                            trueCount++;
                        }
                    }

                    // score_timeout 分数 id 时间
                    /*score_timeout = roundReloaded(trueCount / questionLength * 100, 2);
                    $.ajax({
                        url: config.sendResultsURL,
                        type: "get",
                        dataType: "jsonp",
                        data: "cardId=" + id + "&score=" + score_timeout.toString() + "&time=0000",
                        jsonp: 'callback',
                        jsonpCallback: "callback",
                        success: function(data) {
                            var ysMe = plus.webview.getWebviewById('pages/ys-me.html');
                            mui.fire(ysMe, 'perfectList');
                            test_result = data[0].res;
                            if (test_result == 1) {
                                console.log("提交成绩成功");
                            }
                        },
                        error: function() {
                            alert("error")
                        },
                        async: false
                    });*/


                }
            }, 1000);
        }


        function checkAnswers() {

            var resultArr = [],
                flag = false;
            for (i = 0; i < answers.length; i++) {
                if (answers[i] == userAnswers[i]) {
                    flag = true;
                } else {
                    flag = false;
                }
                resultArr.push(flag);
            }
            return resultArr;
        }

        function roundReloaded(num, dec) {
            var result = Math.round(num * Math.pow(10, dec)) / Math.pow(10, dec);
            return result;
        }

        function judgeSkills(score) {
            var returnString;
            if (score === 100) return config.resultComments.perfect;
            else if (score > 90) return config.resultComments.excellent;
            else if (score > 70) return config.resultComments.good;
            else if (score > 50) return config.resultComments.average;
            else if (score > 35) return config.resultComments.bad;
            else if (score > 20) return config.resultComments.poor;
            else return config.resultComments.worst;
        }
        progressKeeper.hide();
        notice.hide();
        showQuestion.hide();
        slidesList.hide().first().fadeIn(500);
        var clickAnswers = true;
        superContainer.find('li').click(function() {
            var thisLi = $(this);
            if (thisLi.hasClass('selected')) {
                thisLi.removeClass('selected');
            } else {
                thisLi.parents('.answers').children('li').removeClass('selected');
                thisLi.addClass('selected');
            }
        });

        superContainer.find('.nav-start').parents('.slide-container').hide(
            function() {
                $(this).next().fadeIn(500);
                $(".Answer-time-score").fadeIn(500);
                timer(intDiff);
                progressKeeper.fadeIn(500);
            });
        superContainer.find('.nav-start').click(function() {
            id = $(".input__field").val();
            var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            if (reg.test(id) === false) {
                alert("身份证输入不合法");
                return false;
            }
            $(".ID").html(id);
            $(this).parents('.slide-container').fadeOut(500,
                function() {
                    $(this).next().fadeIn(500);
                    $(".Answer-time-score").fadeIn(500);
                    timer(intDiff);
                    progressKeeper.fadeIn(500);
                });
            return false;
        });
        $('.input__field').bind('keyup', function(event) {
            if (event.keyCode == "13") {
                id = $(".input__field").val();
                var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
                if (reg.test(id) === false) {
                    alert("身份证输入不合法");
                    return false;
                }
                $(".ID").html(id);
                $(this).parents('.slide-container').fadeOut(500,
                    function() {
                        $(this).next().fadeIn(500);
                        $(".Answer-time-score").fadeIn(500);
                        timer(intDiff);
                        progressKeeper.fadeIn(500);
                    });
                return false;
            }
        });
        superContainer.find('.next').click(function() {
            showQuestion.hide();
            clickAnswers = true;
            if ($(this).parents('.slide-container').find('li.selected').length === 0) {
                notice.fadeIn(300);
                return false;
            }
            notice.hide();
            $(this).parents('.slide-container').fadeOut(500,
                function() {
                    $(this).next().fadeIn(500);
                });
            progress.animate({
                    width: progress.width() + Math.round(progressWidth / questionLength)
                },
                500);
            return false;
        });
        superContainer.find('.prev').click(function() {
            notice.hide();
            $(this).parents('.slide-container').fadeOut(500,
                function() {
                    $(this).prev().fadeIn(500);
                });
            progress.animate({
                    width: progress.width() - Math.round(progressWidth / questionLength)
                },
                500);
            return false;
        });
        superContainer.find('.final').click(function() {
            window.clearInterval(timers);

            var time = 2700 - (minute * 60 + second);
            if ($(this).parents('.slide-container').find('li.selected').length === 0) {
                notice.fadeIn(300);
                return false;
            }
            var arrayABCD = ["A", "B", "C", "D"];
            superContainer.find('li.selected').each(function(index) {
                userAnswers.push(arrayABCD[$(this).parents('.answers').children('li').index($(this).parents('.answers').find('li.selected'))]);
            });
            progressKeeper.hide();
            var results = checkAnswers(),
                score,
                resultSet = '',
                trueCount = 0,
                shareButton = '',
                url;
            /*   if (config.shortURL === null) {
                config.shortURL = window.location
            };
*/
            /*     for (var i = 0,
                         toLoopTill = results.length; i < toLoopTill; i++) {
                     if (results[i] === true) {
                         trueCount++;
                         isCorrect = true;
                     }
                     resultSet += '<div class="result-row">' + (results[i] === true ? "<div class='correct'>题" + (i + 1) + "<span></span></div>" : "<div class='wrong'>#" + (i + 1) + "<span></span></div>");
                     resultSet += '<div class="resultsview-qhover">' + config.questions[i].question;
                     resultSet += "<ul>";
                     for (answersIteratorIndex = 0; answersIteratorIndex < config.questions[i].answers.length; answersIteratorIndex++) {
                         var classestoAdd = '';
                         if (config.questions[i].correctAnswer == answersIteratorIndex + 1) {
                             classestoAdd += 'right';
                         }
                         if (userAnswers[i] == answersIteratorIndex + 1) {
                             classestoAdd += ' selected';
                         }
                         resultSet += '<li class="' + classestoAdd + '">' + config.questions[i].answers[answersIteratorIndex] + '</li>';
                     }
                     resultSet += '</ul></div></div>';
                 }*/
            score = roundReloaded(trueCount / questionLength * 100, 2);
            var score_string = score.toString();
            if (config.sendResultsURL !== null) {
                var collate = [];
                for (r = 0; r < userAnswers.length; r++) {
                    collate.push('{"questionNumber":"' + parseInt(r + 1, 10) + '", "userAnswer":"' + userAnswers[r] + '"}');
                }

                function getUrl(name) {
                    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
                    var r = window.location.search.substr(1).match(reg);
                    if (r != null) return unescape(r[2]);
                    return "";
                }
                // var cardid = getUrl('idcard');
                var tz = $('#inline-range-val').html();
                var sg = $('#inline-range-field-input').html();
                var blood = $('select[name=blood] option:selected').val();
                console.log(JSON.stringify(userAnswers))
                $.ajax({
                    url: hostUrl + 'xgcs',
                    type: "get",
                    dataType: "jsonp",
                    data: {
                        xgcs: userAnswers,
                        eid: UserInfo.userId(),
                        blood: blood,
                        weight: tz,
                        hight: sg
                    },
                    jsonp: 'callback',
                    jsonpCallback: "callback",
                    success: function(data) {
                        var ysMe = plus.webview.getWebviewById('pages/ys-me.html');
                        mui.fire(ysMe, 'perfectList');
                        id = data.info;
                        // alert(id)
                        resultSet = '<h3 class="qTitle">性格测试结果:' + id + '色性格</h3>';
                        // resultSet += '<div class="jquizzy-content-show">1、红色<br/>【性格优势】：作为个体：高度乐观的积极心态。喜欢自己，也容易接纳别人。把生命当作值得享受的经验。喜欢新鲜、变化和刺激。经常开心，追求快乐。情感丰富而外露。自由自在，不受拘束。喜欢开玩笑和调侃。别出心裁，与众不同。表现力强。容易受到人们的喜欢和欢迎。生动活泼，好奇心强。才思敏捷，善于表达。喜欢通过肢体上的接触传达亲密情感。<br/>【性格过当】：作为个体：情绪波动大起大落。变化无常，随意性强。鲁莽冲动，轻信他人，容易上当受骗。虚荣心强，不肯吃苦，贪图享受。喜欢走捷径，虎头蛇尾，不能坚持。粗心大意，杂乱无章。不肯承担责任，期待有别人为自己的人生负责。缺乏自控，毫无纪律。容易原谅自己，不吸取教训。不稳定和散漫。拒绝长大。借放纵来麻痹自己的痛苦和烦恼，而不去认真思考生命的本质。<br/>2、蓝色<br/>【性格优势】：作为个体：严肃的生活哲学。思想深邃，独立思考而不盲目从众。沉默寡言，老成持重。注重承诺，可靠安全。谨慎而深藏不露。坚守原则，责任心强。遵守规则，井井有条。深沉有目标的理想主义。敏感细腻。高标准，追求完美。谦和稳健。善于分析，富有条理。待人忠诚，富有自我牺牲精神。深思熟虑，三思而后行。坚韧执着。<br/>【性格过当】：作为个体：高度负面的情绪化。猜忌心重，不信任他人。太在意别人的看法和评价，容易被负面评价中伤。容易沮丧，悲观消极。陷于低落的情绪无法自拔。情感脆弱抑郁，有自怜倾向。杞人忧天，庸人自扰。最容易的抑郁症患者。当别人轻易成功时，会因自己的努力付出却不如他人而心生嫉妒。过于阴沉的面孔，让人感觉压抑，不易接近。<br/>3、黄色<br/>【性格优势】：作为个体：不达目标，誓不罢休。不停地给自己设定目标以推动前进。把生命当成竞赛。行动迅速，活力充沛。意志坚强。自信、不情绪化，而且非常有活力。坦率，直截了当，一针见血。强烈的进取心，居安思危。独立性强。有强烈的求胜欲。不畏强权并敢于冒险。不易气馁，不在乎外界的评价，坚持自己所选择的道路和方向。危难时刻挺身而出。讲究速度和效率。敢于接受挑战并渴望成功。<br/>【性格过当】：作为个体：自己永远是对的，死不认错。趾高气扬，霸道。只关注自己的感受，不体贴别人的心情和想法。以自我为中心，自私倾向。霸道。脾气暴躁，容易发怒。缺少同情心。傲慢自大，目中无人。经常紧绷自己的情绪。在情绪不佳或有压力的时候，经常会不可理喻与独断专行。不喜欢受群体所规范约束,打破既定规则且自己不遵守规则。<br/>4、绿色<br/>【性格优势】：作为个体：爱静不爱动，有温柔祥和的吸引力和宁静愉悦的气质。和善的天性，做人厚道。追求人际关系的和谐。奉行中庸之道，为人稳定低调。遇事以不变应万变，镇定自若。知足常乐，心态轻松。追求平淡的幸福生活。有松弛感，能融入所有的环境和场合。从不发火，温和、谦和、平和三和一体。做人懂得“得饶人处且饶人”。追求简单随意的生活方式。<br/>【性格过当】：作为个体：按照惯性来做事，拒绝改变，对于外界变化置若罔闻。懒洋洋的作风，原谅自己的不思进取。懦弱胆小，纵容别人欺压自己。期待事情会自动解决，完全守望被动。得过且过。无原则地妥协，而无法促使他们采取负责任的解决态度。逃避问题与冲突。太在意别人反应，不敢表达自己的立场和原则。</div>';
                        // resultSet += '<a class="results-btn" href=page4.html>点击进入资料录入</a>'
                        superContainer.find('.result-keeper').html(resultSet).show(500);
                        setTimeout(function() {
                                mui.back();
                            }, 2000)
                            // $('.results-btn').on('click', function() {

                        // })

                        $('.jquizzy-show').on('click', function() {
                            $('.jquizzy-content-show').show();
                        })
                    },
                    error: function() {
                        // alert("error");
                    },
                    async: false
                });


            }

            // superContainer.find('.resultsview-qhover').hide();
            // superContainer.find('.result-row').hover(function() {
            //         $(this).find('.resultsview-qhover').show();
            //     },
            //     function() {
            //         $(this).find('.resultsview-qhover').hide();
            //     });
            // $(this).parents('.slide-container').fadeOut(500,
            //     function() {
            //         $(this).next().fadeIn(500);
            //     });
            return false;
        });
    };
})(jQuery);
